/*
 Bit-bang JTAG interface functions
 
 Copyright (c) 2008-2011 Dimtel, Inc., All Rights Reserved

 $Id: jtag.c,v 1.1 2012/11/11 01:24:32 dim Exp $
 $Date: 2012/11/11 01:24:32 $
 $Author: dim $
 $Revision: 1.1 $
 $Log: jtag.c,v $
 Revision 1.1  2012/11/11 01:24:32  dim
 Moved from BxB, adapted to compile for both LLRF4 and IGP12

 Revision 1.1  2011/12/27 19:31:46  dim
 Updated to remove deprecated constructs (at, sfr, xdata, sbit)


*/

#include "fx2regs.h"
#include "common.h"
#include "jtag.h"
#include "hwdef.h"

uchar jtag_rxtx(uchar value)
{
  unsigned char ret;
  
  JTAG_TMS = (value >> 1) & 1;
  JTAG_TDI = value & 1;
  JTAG_TCK = 1;
  ret = JTAG_TDO;
  JTAG_TCK = 0;
            
  return ret;
}

void jtag_block_write(__xdata uchar *buf, uchar len)
{
	(void) buf; /* only used in assembly */
	(void) len; /* only used in assembly */
    __asm
	mov     r2, _jtag_block_write_PARM_2
_jtag_block_write_loop:
	movx    a, @dptr
	
        rlc     a
	mov     _JTAG_TDI, c

	setb    _JTAG_TCK
	rlc     a
	clr     _JTAG_TCK
	mov     _JTAG_TDI, c

	setb    _JTAG_TCK
	rlc     a
	clr     _JTAG_TCK
	mov     _JTAG_TDI, c

	setb    _JTAG_TCK
	rlc     a
	clr     _JTAG_TCK
	mov     _JTAG_TDI, c

	setb    _JTAG_TCK
	rlc     a
	clr     _JTAG_TCK
	mov     _JTAG_TDI, c

	setb    _JTAG_TCK
	rlc     a
	clr     _JTAG_TCK
	mov     _JTAG_TDI, c

	setb    _JTAG_TCK
	rlc     a
	clr     _JTAG_TCK
	mov     _JTAG_TDI, c

	setb    _JTAG_TCK
	rlc     a
	clr     _JTAG_TCK
	mov     _JTAG_TDI, c

	setb    _JTAG_TCK
	rlc     a
	clr     _JTAG_TCK

	inc     dptr
	djnz    r2, _jtag_block_write_loop
    __endasm;
}
